#!/usr/bin/env python

import sys, re
from htmlentitydefs import entitydefs

entitydefs["apos"] = "'"    # bah, that sucks.
if entitydefs.has_key ("amp"):
   del entitydefs["amp"]       # special case


def get_idlefuncs (bot):
   bot.logfile = getattr (bot, "logfile", None)
   bot.logregex = re.compile ("(?ims).*?(<start .*?</start>)")
   bot.logcollect = getattr (bot, "logcollect", "")
   return [
      (watch_logfiles, (), {})
   ]


def unentitify (data):
   entities = re.findall ("&\w+;", data)
   entitydict = {}
   for i in entities:
      entitydict [i] = 1
   entities = entitydict.keys ()   # make uniqe
   
   for i in entities:
      data = data.replace (i, entitydefs.get (i[1:-1], i))

   return data.replace ("&amp;", "&")


def watch_logfiles (bot):
   didsomething = 0
   if not bot.logfile:
      bot.logfile = open ("/home/simon/tail-blccc.log", "r")
      bot.logfile.read () # discard ancient data

   data = bot.logfile.read ()
   if data:
      didsomething = 1
      bot.logcollect += data
      match = bot.logregex.search (bot.logcollect)
      while match:
         entry = match.group (1)
         title = "(No Title)"
         titlematch = re.search ("<title>(.*?)</title>", entry)
         if titlematch:
            title = unicode(titlematch.group (1),"utf-8").encode("iso-8859-1")

         author = "(Unknown)"
         authormatch = re.search ("<author>(.*?)</author>", entry)
         if authormatch:
            author = unicode(authormatch.group (1),"utf-8").encode("iso-8859-1")

         if bot.channels:
            bot.privmsg (bot.channels[0],
                         "playing '%s' by %s" % (unentitify (title),
                                                 unentitify (author)))
         bot.logcollect = bot.logcollect[match.end():]
         match = bot.logregex.search (bot.logcollect)

   return didsomething


   
